package kd.hrmp.hbjm.business.domain.repository;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.util.CollectionUtils;
import kd.hr.hbp.business.servicehelper.HRBaseServiceHelper;
import kd.hr.hbp.common.constants.HRBaseConstants;
import kd.hr.hbp.common.constants.HRHisBaseConstants;
import kd.hr.hbp.common.constants.newhismodel.HisFieldNameConstants;
import kd.hr.hbp.common.util.HRDateTimeUtils;
import kd.hrmp.hbjm.common.constants.HBJMConstants;
import kd.hrmp.hbjm.common.constants.JobConstans;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @author rd_xiangquan_zheng
 * @since 2021/12/28 15:23
 */
public class HBJMHisRepository {
    private static class JobHisQueryRepository {
        private static HBJMHisRepository INSTANCE = new HBJMHisRepository();
    }

    public static HBJMHisRepository getInstance() {
        return HBJMHisRepository.JobHisQueryRepository.INSTANCE;
    }

    public DynamicObjectCollection getNumAndNameList(List<Long> boidList, Date time, String entityname) {
        QFilter effdtQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, HRDateTimeUtils.truncateDate(time));
        QFilter bsledQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, HRDateTimeUtils.truncateDate(time));
        QFilter boidQFilter = new QFilter(HBJMConstants.BOID, QCP.in, boidList);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        String selectFields = "boid,id,number,name";
        QFilter qFilter =
                effdtQFilter.and(bsledQFilter).and(boidQFilter).and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter);
        return QueryServiceHelper.query(entityname, selectFields, new QFilter[]{qFilter});
    }

    public DynamicObjectCollection getJobHis(List<Long> boidList, Date time) {
        String selectFields =
                "boid,id,number,name,createorg,jobscm.id,jobscm.name,jobscm.number,jobscm.jobgradescm.id,jobscm.jobgradescm.name, " +
                        "jobscm.jobgradescm.number, jobscm.joblevelscm.id, jobscm.joblevelscm.number, jobscm.joblevelscm.name, " +
                        "jobseq.name,jobseq.id,jobfamily.name,jobfamily.id,jobclass.name,jobclass.id, highjobgrade.jobgradescm.id," +
                        "highjobgrade.jobgradescm.number,highjobgrade.jobgradescm.name, highjoblevel.joblevelscm.id," +
                        "highjoblevel.joblevelscm.number,highjoblevel.joblevelscm.name, highjobgrade.name,highjobgrade.id,lowjobgrade.name,lowjobgrade.id,highjoblevel.name,highjoblevel.id,lowjoblevel.name,lowjoblevel.id," +
                        "createorg.name,createorg.number";
        return getJobHis(boidList, time, selectFields);
    }

    public DynamicObjectCollection getJobHis(List<Long> boidList, Date time, String selectFields) {
        QFilter effdtQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, HRDateTimeUtils.truncateDate(time));
        QFilter bsledQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, HRDateTimeUtils.truncateDate(time));
        QFilter boidQFilter = new QFilter(HBJMConstants.BOID, QCP.in, boidList);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        QFilter qFilter =
                effdtQFilter.and(bsledQFilter).and(boidQFilter).and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter);
        return QueryServiceHelper.query(HBJMConstants.PAGE_HBJM_JOB, selectFields, new QFilter[]{qFilter});
    }

    public DynamicObjectCollection getJobHisSimpleInfo(List<String> numberList, Date time) {
        QFilter boidQFilter = new QFilter(HRBaseConstants.NUMBER, QCP.in, numberList);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, HRBaseConstants.STR_ZERO);
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        QFilter effdtQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, HRDateTimeUtils.truncateDate(time));
        QFilter bsledQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, HRDateTimeUtils.truncateDate(time));
        QFilter qFilter = boidQFilter.and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter).and(effdtQFilter).and(bsledQFilter);
        String selectFields = "boid,id,number,name,enable,firstbsed";
        return QueryServiceHelper.query(HBJMConstants.PAGE_HBJM_JOB, selectFields, new QFilter[]{qFilter});
    }

    public DynamicObject[] getJobFirstBsedByNumber(List<String> numberList) {
        HRBaseServiceHelper helper = new HRBaseServiceHelper(HBJMConstants.PAGE_HBJM_JOB);
        QFilter boidQFilter = new QFilter(HRBaseConstants.NUMBER, QCP.in, numberList);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, HRBaseConstants.STR_ONE);
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);

        QFilter qFilter = boidQFilter.and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter);
        String selectFields = "boid,id,firstbsed";
        return helper.queryOriginalArray(selectFields, new QFilter[]{qFilter});
    }

    public DynamicObject[] getJobHisById(List<Long> idList) {
        HRBaseServiceHelper serviceHelper = new HRBaseServiceHelper(HBJMConstants.PAGE_HBJM_JOB);
        QFilter boidQFilter = new QFilter(HRBaseConstants.ID, QCP.in, idList);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        QFilter qFilter = boidQFilter.and(iscurrentversionQfilter).and(initStatusFilter);
        return serviceHelper.loadDynamicObjectArray(new QFilter[]{qFilter});
    }

    public DynamicObjectCollection getJobVersionInfo(List<Long> boidList, Date start, Date end) {

        Date start_data = HRDateTimeUtils.truncateDate(start);
        Date end_data = HRDateTimeUtils.truncateDate(end);

        //开始时间在这个版本生效时间内
        QFilter effdtQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, start_data);
        effdtQFilter.and(new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, start_data));

        //结束时间在这个版本生效时间内
        QFilter bsledQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, end_data);
        bsledQFilter.and(new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, end_data));

        //生效日期大于开始日期 失效日期小于结束日期（传的时间段包含这一整段历史）
        QFilter bsledQFilterMul =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.large_equals, start_data);
        bsledQFilterMul.and(new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.less_equals, end_data));

        QFilter timeFilter = effdtQFilter.or(bsledQFilter).or(bsledQFilterMul);

        QFilter boidQFilter = new QFilter(HBJMConstants.BOID, QCP.in, boidList);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_EFFECTING, HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        String selectFields =
                "boid,id,number,name,bsed,bsled";
        QFilter qFilter =
                timeFilter.and(boidQFilter).and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter);
        return QueryServiceHelper.query(HBJMConstants.PAGE_HBJM_JOB, selectFields, new QFilter[]{qFilter});
    }

    public DynamicObjectCollection getHbjmClassInfo(List<Long> boidList, Date time, String entityname) {
        QFilter effdtQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, HRDateTimeUtils.truncateDate(time));
        QFilter bsledQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, HRDateTimeUtils.truncateDate(time));
        QFilter boidQFilter = new QFilter(HBJMConstants.BOID, QCP.in, boidList);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        String selectFields =
                "boid,id,number,name,jobfamily,jobfamily.name,parent,parent.name,jobseq,jobseq.name,jobclasslevel";
        QFilter qFilter =
                effdtQFilter.and(bsledQFilter).and(boidQFilter).and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter);
        return QueryServiceHelper.query(entityname, selectFields, new QFilter[]{qFilter});
    }

    public DynamicObjectCollection getFamilyInfo(List<Long> boidList, Date time, String entityname) {
        QFilter effdtQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, HRDateTimeUtils.truncateDate(time));
        QFilter bsledQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, HRDateTimeUtils.truncateDate(time));
        QFilter boidQFilter = new QFilter(HBJMConstants.BOID, QCP.in, boidList);
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        String selectFields = "boid,id,number,name,jobseq,jobseq.name";
        QFilter qFilter =
                effdtQFilter.and(bsledQFilter).and(boidQFilter).and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter);
        return QueryServiceHelper.query(entityname, selectFields, new QFilter[]{qFilter});
    }

    public List<Map<String, Object>> getGradeInfo(List<Long> idList, Date time, String entityname) {
        DynamicObjectCollection jobdyncol = QueryServiceHelper.query(entityname, "jobgradescm,entryboid",
                new QFilter[]{new QFilter(HRBaseConstants.ID, QCP.in, idList)});
        List<Map<String, Object>> reslist = new ArrayList<>(jobdyncol.size());
        List<Long> entryboids =
                jobdyncol.stream().map(jobdyn -> jobdyn.getLong("entryboid")).collect(Collectors.toList());
        QFilter effdtQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, HRDateTimeUtils.truncateDate(time));
        QFilter bsledQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, HRDateTimeUtils.truncateDate(time));
        QFilter entryboidQFilter = new QFilter("entryentity.entryboid", QCP.in, entryboids);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        QFilter qFilter =
                effdtQFilter.and(bsledQFilter).and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter).and(entryboidQFilter);

        DynamicObjectCollection jobscmdyncollection = QueryServiceHelper.query("hbjm_jobgradescmhr",
                "entryentity,entryentity.jobgrade_number,entryentity.jobgrade_name, entryentity.entryboid", new QFilter[]{qFilter});
        if (CollectionUtils.isEmpty(jobscmdyncollection)) {
            return null;
        }
        for (DynamicObject jobscmdyn : jobscmdyncollection) {
            Map<String, Object> resmap = new HashMap(3);
            String number = jobscmdyn.getString("entryentity.jobgrade_number");
            String name = jobscmdyn.getString("entryentity.jobgrade_name");
            resmap.put(HRBaseConstants.ID, jobscmdyn.getLong(HBJMConstants.ENTRYENTITY));
            resmap.put(HisFieldNameConstants.BOID, jobscmdyn.getLong("entryentity.entryboid"));
            resmap.put(HRBaseConstants.NUMBER, number);
            resmap.put(HRBaseConstants.NAME, name);
            reslist.add(resmap);
        }
        return reslist;
    }

    public List<Map<String, Object>> getLevelInfo(List<Long> idList, Date time, String entityname) {
        DynamicObjectCollection jobdyncol = QueryServiceHelper.query(entityname, "joblevelscm,entryboid",
                new QFilter[]{new QFilter(HRBaseConstants.ID, QCP.in, idList)});
        List<Map<String, Object>> reslist = new ArrayList<>(jobdyncol.size());
        List<Long> entryboids =
                jobdyncol.stream().map(jobdyn -> jobdyn.getLong("entryboid")).collect(Collectors.toList());
        QFilter effdtQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSED, QCP.less_equals, HRDateTimeUtils.truncateDate(time));
        QFilter bsledQFilter =
                new QFilter(HRHisBaseConstants.FIELD_BSLED, QCP.large_equals, HRDateTimeUtils.truncateDate(time));
        QFilter entryboidQFilter = new QFilter("entryentity.entryboid", QCP.in, entryboids);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        QFilter qFilter =
                effdtQFilter.and(bsledQFilter).and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter).and(entryboidQFilter);

        DynamicObjectCollection jobscmdyncollection = QueryServiceHelper.query("hbjm_joblevelscmhr",
                "entryentity,entryentity.joblevel_number,entryentity.joblevel_name, entryentity.entryboid", new QFilter[]{qFilter});
        if (CollectionUtils.isEmpty(jobscmdyncollection)) {
            return null;
        }
        jobscmdyncollection.stream().forEach(jobscmdyn -> {
            Map<String, Object> resmap = new HashMap(3);
            String number = jobscmdyn.getString("entryentity.joblevel_number");
            String name = jobscmdyn.getString("entryentity.joblevel_name");
            resmap.put(HRBaseConstants.ID, jobscmdyn.getLong(HBJMConstants.ENTRYENTITY));
            resmap.put(HisFieldNameConstants.BOID, jobscmdyn.getLong("entryentity.entryboid"));
            resmap.put(HRBaseConstants.NUMBER, number);
            resmap.put(HRBaseConstants.NAME, name);
            reslist.add(resmap);
        });
        return reslist;
    }

    /**
     * 查询职位版本数据
     *
     * @param versionId
     * @return
     */
    public DynamicObject getJobVersionInfoByVersionId(long versionId) {
        HRBaseServiceHelper eventsumHelper = new HRBaseServiceHelper(JobConstans.PAGE_HJMS_JOB);
        QFilter[] qFilters = new QFilter[]{new QFilter(HRBaseConstants.ID, QFilter.equals, versionId)};
        String selectFields = "id,boid,number,name,jobscm,jobseq,jobfamily,jobclass,"
                + "jobtype,lowjobgrade,highjobgrade,lowjoblevel,highjoblevel,"
                + "establishmentdate,joborientation,jobstandard,diplomareq,agereq,knowledgereq,jobduty,"
                + "skillreq,abilityreq,experiencereq,createorg,ctrlstrategy,bsed";
        return eventsumHelper.queryOriginalOne(selectFields, qFilters);
    }

    /**
     * 查询职位当前生效的数据
     *
     * @param jobBoids
     * @return
     */
    public DynamicObject[] getJobCurrentVersionByBoid(List<Long> jobBoids) {
        HRBaseServiceHelper eventsumHelper = new HRBaseServiceHelper(JobConstans.PAGE_HJMS_JOB);
        QFilter boFilter = new QFilter(HisFieldNameConstants.BOID, QFilter.in, jobBoids);
        QFilter iscurrentVersionFilter =
                new QFilter(HisFieldNameConstants.IS_CURRENT_VERSION, QFilter.equals, HisFieldNameConstants.STR_TRUE);
        String selectFields = "id,boid,number,name,jobscm,jobseq,jobfamily,jobclass,"
                + "jobtype,lowjobgrade,highjobgrade,lowjoblevel,highjoblevel,"
                + "establishmentdate,joborientation,jobstandard,diplomareq,agereq,knowledgereq,jobduty,"
                + "skillreq,abilityreq,experiencereq,createorg,ctrlstrategy,bsed";
        return eventsumHelper.queryOriginalArray(selectFields, new QFilter[]{boFilter, iscurrentVersionFilter});
    }

    public DynamicObject[] getJobHisByBoId(List<Long> boidList) {
        HRBaseServiceHelper serviceHelper = new HRBaseServiceHelper(HBJMConstants.PAGE_HBJM_JOB);
        QFilter boidQFilter = new QFilter(HisFieldNameConstants.BOID, QCP.in, boidList);
        QFilter iscurrentversionQfilter = new QFilter(JobConstans.IS_CURRENT_VERSION, QCP.equals, "0");
        QFilter datastatusQFilter = new QFilter(HRHisBaseConstants.FIELD_DATASTATUS, QCP.in,
                new String[]{HRHisBaseConstants.EFFECTSTATUS_SCHEDULEEFFECT, HRHisBaseConstants.EFFECTSTATUS_EFFECTING,
                        HRHisBaseConstants.EFFECTSTATUS_INVALID});
        QFilter initStatusFilter = new QFilter(HBJMConstants.INIT_STATUS, QFilter.equals, HBJMConstants.INIT_STATUS_COMPLETE);
        QFilter qFilter = boidQFilter.and(datastatusQFilter).and(iscurrentversionQfilter).and(initStatusFilter);
        return serviceHelper.loadDynamicObjectArray(new QFilter[]{qFilter});
    }
}
