package kd.hrmp.hbjm.business.jobclass;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.utils.ArrayUtils;
import kd.bos.entity.tree.TreeNode;
import kd.bos.orm.query.QFilter;
import kd.bos.orm.util.CollectionUtils;
import kd.hr.hbp.business.servicehelper.HRBaseServiceHelper;
import kd.hr.hbp.common.constants.HRBaseConstants;
import kd.hr.hbp.common.util.HRStringUtils;
import kd.hrmp.hbjm.business.domain.repository.JobClassRepository;

import java.util.*;


/**
 * @author pWX1002953
 * @since 2020年11月07日10:37:42
 * 职位树公共方法类
 */
public class JobClassTreeService {
    /**
     * 通过当前节点给右表设置过滤
     *
     * @param nodeId 当前节点
     * @return QFilter 过滤条件
     */
    public static QFilter builJobClassQFilter(String nodeId) {
        Long userId = RequestContext.get().getCurrUserId();
        if (null != nodeId && !HRStringUtils.isEmpty(nodeId)) {
            String nodeLayer = nodeId.substring(0, 1);
            Long seqId = 0L;
            String[] split = nodeId.split("#");
            String lastNodeId = split[split.length - 1];
            List<Long> ids = new ArrayList<>();
            ids.add(Long.valueOf(lastNodeId.substring(1)));
            QFilter qFilter;
            switch (nodeLayer) {
                case "0":
                    qFilter = JobClassRepository.getInstance().getClassFilter(userId,Boolean.FALSE);
                    break;
                case "1":
                    qFilter = buildJobFilter(seqId, ids, HRBaseConstants.ID, "jobseq.id");
                    break;
                case "2":
                    qFilter = buildJobFilter(seqId, ids, HRBaseConstants.ID, "jobfamily.id");
                    break;
                default:
                    String strId = nodeId.substring(1, nodeId.length());
                    qFilter = new QFilter("parent", QFilter.equals, Long.parseLong(strId));
                    qFilter.or(new QFilter("id", QFilter.equals, Long.parseLong(strId)));
                    qFilter.and(JobClassRepository.getInstance().getClassFilter(userId,Boolean.FALSE));
                    break;
            }
            return qFilter;
        }
        return null;
    }

    private static QFilter buildJobFilter(Long seqId, List<Long> ids, String filterCondition, String field) {
        List<Long> longs = JobClassRepository.getInstance().queryJobId(seqId, ids, field, Boolean.FALSE);
        return new QFilter(filterCondition, QFilter.in, longs);
    }
}
