package kd.hrmp.hbjm.business.utils;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.service.operation.OperationServiceImpl;
import kd.hr.hbp.common.constants.HRBaseConstants;
import kd.hr.hbp.common.util.HRStringUtils;

/**
* @description:职位工具类
* @author rd_ningjie
* @date  2022/10/17 16:41
*/
public class JobUtils {

    /**
     * OP保存
     *
     * @param opKey          操作Key
     * @param dynamicObjects 保存数据
     * @return OperationResult
     */
    public static OperationResult callOp(String opKey, DynamicObject[] dynamicObjects) {
        OperationServiceImpl opImpl = new OperationServiceImpl();
        OperateOption operateOption = OperateOption.create();
        return opImpl.localInvokeOperation(opKey, dynamicObjects, operateOption);
    }

    /**
     * 判断数据是否是 待启用或者不是审核状态的
     *
     * @param dataEntity 校验数据
     * @return 是否是目标数据
     */
    public static boolean isEnablingOrNoAuditData(DynamicObject dataEntity) {
        return HRStringUtils.equals(dataEntity.getString(HRBaseConstants.ENABLE), HRBaseConstants.ENABLING)
                || !HRStringUtils.equals(dataEntity.getString(HRBaseConstants.STATUS), HRBaseConstants.STATUS_AUDIT);
    }
}
