package kd.hrmp.hbjm.business.utils;

import kd.bos.inte.api.EnabledLang;
import kd.bos.inte.api.IInteService;
import kd.bos.lang.Lang;
import kd.bos.service.ServiceFactory;
import kd.hr.hbp.common.util.HRStringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @author rd_ningjie
 * @description:多语言工具
 * @date 2022/10/9 14:02
 */
public class MuliLangUtils {


    /**
     * @description: 获取所有支持的语言
     * @return: java.util.List<kd.bos.lang.Lang>
     * @author rd_ningjie
     * @date: 2022/10/9 14:05
     */
    public static List<Lang> getEnabedLang() {
        IInteService service = ServiceFactory.getService(IInteService.class);
        List<EnabledLang> enabledLangList = service.getEnabledLang();
        List<Lang> result = null;
        if (enabledLangList != null && enabledLangList.size() > 0) {
            result = new ArrayList<>(enabledLangList.size());
            for (int ii = 0; ii < enabledLangList.size(); ii++) {
                result.add(Lang.from(enabledLangList.get(ii).number));
            }
        }
        return result;
    }

    /**
     * @param lang
     * @description: 判断是否支持该多语言
     * @return: boolean
     * @author rd_ningjie
     * @date: 2022/10/9 14:07
     */
    public static boolean isSupportLang(String lang) {

        boolean support = false;
        if (HRStringUtils.isEmpty(lang)) {
            return support;
        }
        List<Lang> enabedLang = MuliLangUtils.getEnabedLang();
        if (enabedLang == null || enabedLang.size() <= 0) {
            return support;
        }
        for (Lang info : enabedLang) {
            if (HRStringUtils.equals(info.name(), lang)) {
                return true;
            }
        }
        return support;
    }
}
